//*******************************************************************
//
//  UNIT:     B l u r                       06.09.99,  06.09.99
//
//  bluring routines for delphi 4.
//
//-------------------------------------------------------------------
//  Blur2               bluring with 2 pixels
//
//*******************************************************************
unit Blur;

interface

uses Graphics;

procedure Blur2H (source, dest: tBitmap; y1,y2: cardinal);
procedure Blur3H (source, dest: tBitmap; y1,y2: cardinal);
procedure Blur4Q (source, dest: tBitmap; y1,y2: cardinal);

//*********************************************************
implementation

//*********************************************************
procedure Blur2H (source, dest: tBitmap; y1,y2: cardinal);
var  xi, yi: cardinal;
     p1: byte;
     sp, dp: ^byte;
begin
  for yi := y1 to y2
  do begin
    sp := source.ScanLine[yi];
    dp :=   dest.ScanLine[yi];
    for xi := 1 to source.Width
    do begin
      p1 := sp^;
      inc (sp);
      dp^ := (p1 + sp^) shr 1;
      inc (dp);
    end;
  end;
end;
//*********************************************************
procedure Blur3H (source, dest: tBitmap; y1,y2: cardinal);
var  xi, yi: cardinal;
     p1, p2: byte;
     sp, dp: ^byte;
begin
  for yi := y1 to y2
  do begin
    sp := source.ScanLine[yi];
    dp :=   dest.ScanLine[yi];
    inc (dp);
    p1 := sp^;
    inc (sp);
    for xi := 2 to source.Width
    do begin
      p2 := sp^;
      inc (sp);
      dp^ := (p1 + p2 shl 1 + sp^) shr 2;
//    dp^ := (p1 + p2 shl 1 + sp^ + 1) shr 2;
      inc (dp);
      p1 := p2;
    end;
  end;
end;
//*********************************************************
procedure Blur4Q (source, dest: tBitmap; y1,y2: cardinal);
var  xi, yi: cardinal;
     p1, p2: word;
     s1, s2, dp: ^byte;
begin
  s1 := source.ScanLine[y1];
  for yi := y1 to y2-1
  do begin
    s2 := source.ScanLine[yi+1];
    dp :=   dest.ScanLine[yi];
    p1 := s1^ + s2^ + 1;
    inc (s1);
    inc (s2);
    for xi := 2 to source.Width
    do begin
      p2 := s1^ + s2^ + 1;
      inc (s1);
      inc (s2);
      dp^ := (p1+p2) shr 2;
      inc (dp);
      p1 := p2;
    end;
    s1 := s2;
  end;
end;

end.
