
//*******************************************************************
//
//  UNIT:     G r A b o u t                      29.06.98,  03.09.99
//
//  information window of GrDemo.DPR
//
//*******************************************************************
unit GrAbout;

interface

uses Forms, Windows, ExtCtrls, Controls, StdCtrls, Classes, SysUtils,
  Graphics, Dialogs, ShellApi;

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Image1: TImage;
    OK: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    LT1: TLabel;
    LT2: TLabel;
    LT3: TLabel;
    LT4: TLabel;
    LI0: TLabel;
    LI1: TLabel;
    LI2: TLabel;
    LI3: TLabel;
    LI4: TLabel;
    LI5: TLabel;
    LK1: TLabel;
    LK2: TLabel;
    LK3: TLabel;
    LK4: TLabel;
    LK5: TLabel;
    LK6: TLabel;
    LK7: TLabel;
    LK8: TLabel;
    LK9: TLabel;
    LK10: TLabel;
    LK11: TLabel;
    PrintDialog1: TPrintDialog;
    procedure Activate(Sender: TObject);  reintroduce;
    procedure OKClick(Sender: TObject);
    procedure httpClick(Sender: TObject);
    procedure mailClick(Sender: TObject);
    procedure printClick(Sender: TObject);
   private
    procedure SysInfo;
    procedure MemInfo;
    procedure DisplayInfo;
  end;

var  AboutBox: TAboutBox;

implementation

{$R *.DFM}

//*********************************************************
procedure TAboutBox.SysInfo;

const opSystem: array[0..3] of string[14]
      =('unknown ','Windows 3.1 ','Windows NT ','Windows 95 ');

var   OSInfo: TOSVersionInfo;
      id: byte;
begin
  OSInfo.dwOSVersionInfoSize := sizeof(TOSVERSIONINFO);
  GetVersionEx(OSInfo);
  case OSInfo.dwPlatformID of
    VER_PLATFORM_WIN32S: 	id := 1;
    VER_PLATFORM_WIN32_NT:	id := 2;
    VER_PLATFORM_WIN32_WINDOWS: id := 3;
    else id := 0;
  end;
  {windows version}
  Label1.Caption := opSystem[id] + IntToStr(OSInfo.dwMajorVersion)
                           + '.' + IntToStr(OSInfo.dwMinorVersion);
end;

//********************************************************
function GetCPUSpeed: Double; // works only for Pentium and higher

const  DelayTime = 100; // measure time in ms
var    TimerHi, TimerLo: DWORD;
begin
  Sleep(10);
  asm
    dw 310Fh // rdtsc
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Sleep(DelayTime);
  asm
    dw 310Fh // rdtsc
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Result := TimerLo / (1000.0 * DelayTime);
end;
//********************************************************
procedure TAboutBox.MemInfo;
var   MemInfo: TMemoryStatus;
begin
  MemInfo.dwLength := sizeof(TMemoryStatus);
  GlobalMemoryStatus(MemInfo);
  Label2.Caption := Format('%d KB',[Trunc(MemInfo.dwTotalPhys/1024)]);
end;

//*********************************************************
procedure TAboutBox.DisplayInfo;
var   dc: HDC;
      rx,ry,bb: integer;
begin
  dc := GetDc(GetActiveWindow);
  rx := GetDeviceCaps (dc, HORZRES);
  ry := GetDeviceCaps (dc, VERTRES);
  bb := GetDeviceCaps (dc, BITSPIXEL)
       *GetDeviceCaps (dc, PLANES);
  Label3.Caption := Format('%d*%d', [rx,ry]);
  Label4.Caption := Format('%d',[bb]);
  Label5.Caption := Format('%d MHz',[trunc(GetCPUSpeed)]);
end;

//*********************************************************
procedure TAboutBox.Activate(Sender: TObject);
begin
  SysInfo;
  MemInfo;
  DisplayInfo;
end;

//*********************************************************
procedure TAboutBox.OKClick(Sender: TObject);
begin
  Close;
end;

//*********************************************************
procedure TAboutBox.httpClick(Sender: TObject);
const homepage=
'http://www.geocities.com/SiliconValley/Sector/7061/download.htm'#0;
begin
  ShellExecute(0, Nil, homepage, Nil, Nil, SW_NORMAL);
end;
//*********************************************************
procedure TAboutBox.mailClick(Sender: TObject);
const mailto = 'mailto:MrPix@geocities.com'#0;
begin
  ShellExecute(0, Nil, mailto, Nil, Nil, SW_NORMAL);
end;
//*********************************************************
procedure TAboutBox.PrintClick(Sender: TObject);
begin
  if PrintDialog1.Execute then Print;
end;

end.

